uses GraphABC,ABCObjects,ABCButtons,Events;

const
  freqcharstr='';

const
  maxwordlen=12;
  scorehits: array [1..maxwordlen] of integer = (0,1,2,4,7,11,16,22,29,37,46,56);

type
  MySquareABC=class(SquareABC) end;

var
  b,b1: ObjectBoardABC;
  x,y: integer;
  cur,moves,score: integer;
  r: RectangleABC;
  btnew,btword,btplease: ButtonABC;

function WordExists(s: string): boolean;
var
  f: text;
  str: string;
begin
  s:=LowerCase(s);
  Result:=False;
  assign(f,'words.txt');
  reset(f);
  while not eof(f) do
  begin
    readln(f,str);
    if s=str then
    begin
      Result:=True;
      break;
    end;
  end;
  close(f);
end;

procedure MyMouseDown(x,y,mb: integer);
var
  ob,ob1: ObjectABC;
  xx,yy,i: integer;
  s: string;
begin
  if mb=1 then
  begin
    if cur>b1.DimX then
      exit;
    ob:=ObjectUnderPoint(x,y);
    if ob is MySquareABC then
    begin
      ob1:=b1.GetObject(cur,1);
      ob1.Visible:=True;
      ob1.Text:=ob.Text;
      Inc(cur);
      ob.Visible:=False;
      s:='';
      for i:=1 to cur-1 do
        s:=s+b1.GetObject(i,1).Text;
      if WordExists(s) then
        b1.Color:=clYellow
      else b1.Color:=clSkyBlue
    end;
  end
  else
  begin
    for xx:=1 to cur-1 do
      b1.GetObject(xx,1).Visible:=False;
    for xx:=1 to b.DimX do
    for yy:=1 to b.DimY do
      b.GetObject(xx,yy).Visible:=True;
    cur:=1;
    b1.Color:=clSkyBlue
  end;
end;

procedure BtNewClick;
var xx,yy: integer;
begin
  score:=0;
  moves:=0;
  r.Text:=': '+IntToStr(moves)+'   : '+IntToStr(score);
  MyMouseDown(1,1,2);
  for xx:=1 to b.DimX do
  for yy:=1 to b.DimY do
    b.GetObject(xx,yy).Text:=UpCase(freqcharstr[Random(255)+1]);
end;

procedure BtWordClick;
var xx,yy: integer;
begin
  if b1.Color<>clYellow then
    exit;
  Inc(score,scorehits[cur-1]);
  Inc(moves);
  for xx:=1 to cur-1 do
    b1.GetObject(xx,1).Visible:=False;
  for xx:=1 to b.DimX do
  for yy:=1 to b.DimY do
    if not b.GetObject(xx,yy).Visible then
    begin
      b.GetObject(xx,yy).Visible:=True;
      b.GetObject(xx,yy).Text:=UpCase(freqcharstr[Random(255)+1]);
    end;
  cur:=1;
  b1.Color:=clSkyBlue;
  r.Text:=': '+IntToStr(moves)+'   : '+IntToStr(score);
end;


procedure BtPleaseClick;
var
  f: text;
  str,maxstr: string;
  arr,work: array [''..''] of integer;
  c: char;
  xx,yy,maxlen: integer;

  function CanConstructWord(s: string): boolean;
  var
    c: char;
    i: integer;
  begin
    work:=arr;
    Result:=True;
    for i:=1 to Length(s) do
    begin
      Dec(work[s[i]]);
      if work[s[i]]<0 then
      begin
        Result:=False;
        break;
      end;
    end;
  end;

begin
  maxlen:=0;
  maxstr:='';
  for c:='' to '' do
    arr[c]:=0;

  for xx:=1 to b.DimX do
  for yy:=1 to b.DimY do
    Inc(arr[LowCase(b.GetObject(xx,yy).Text[1])]);

  assign(f,'words.txt');
  reset(f);
  while not eof(f) do
  begin
    readln(f,str);
    if CanConstructWord(str) and (Length(str)>maxlen) and (Length(str)<=maxwordlen) then
    begin
      maxlen:=Length(str);
      maxstr:=str;
    end;
  end;
  close(f);
  writeln(maxstr);
end;

procedure MyKeyPress(c: char);
begin
  // Esc   !
end;

begin
  cls;
  SetWindowSize(640,480);
  SetWindowCaption('  !');
  SetBrushColor(clMoneyGreen);
  FillRect(0,0,WindowWidth,WindowHeight);
  cur:=1;
  
  btword:=ButtonABC.Create(70,410,180,30,' ',clLtGray);
  btnew:=ButtonABC.Create(280,410,100,30,'',clLtGray);
  btplease:=ButtonABC.Create(410,410,160,30,'',clLtGray);
  btnew.OnClick:=BtNewClick;
  btword.OnClick:=BtWordClick;
  btplease.OnClick:=BtPleaseClick;

  r:=RectangleABC.Create(70,350,500,30,clSkyBlue);
  r.Text:=': 0   : 0';
  b1:=ObjectBoardABC.Create(20,40,maxwordlen,1,50,clSkyBlue);
  b:=ObjectBoardABC.Create(220,120,4,4,50,clMoneyGreen);
  b.BorderColor:=clGreen;
  b.Bordered:=False;

  for x:=1 to b1.DimX do
  begin
    b1.SetObject(x,1,SquareABC.Create(0,0,b1.CellSize-6,clWhite));
    b1.GetObject(x,1).Visible:=False;
  end;
  for x:=1 to b.DimX do
  for y:=1 to b.DimY do
  begin
    b.SetObject(x,y,MySquareABC.Create(0,0,b.CellSize-6,clWhite));
    b.GetObject(x,y).Text:=UpCase(freqcharstr[Random(255)+1]);
  end;
  OnMouseDown:=MyMouseDown;
  OnKeyPress:=MyKeyPress;
end.